diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-txop-test.cc ns-3.42/src/wifi/test/wifi-txop-test.cc
--- ns-3.41/src/wifi/test/wifi-txop-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-txop-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -20,7 +20,10 @@
 #include "ns3/ap-wifi-mac.h"
 #include "ns3/boolean.h"
 #include "ns3/config.h"
+#include "ns3/he-phy.h"
+#include "ns3/log.h"
 #include "ns3/mobility-helper.h"
+#include "ns3/multi-model-spectrum-channel.h"
 #include "ns3/packet-socket-client.h"
 #include "ns3/packet-socket-helper.h"
 #include "ns3/packet-socket-server.h"
@@ -29,7 +32,6 @@
 #include "ns3/qos-txop.h"
 #include "ns3/qos-utils.h"
 #include "ns3/rng-seed-manager.h"
-#include "ns3/single-model-spectrum-channel.h"
 #include "ns3/spectrum-wifi-helper.h"
 #include "ns3/string.h"
 #include "ns3/test.h"
@@ -40,23 +42,47 @@
 
 using namespace ns3;
 
+NS_LOG_COMPONENT_DEFINE("WifiTxopTest");
+
 /**
  * \ingroup wifi-test
  * \ingroup tests
  *
  * \brief Test TXOP rules
  *
- *
+ * A BSS consisting of an AP and 3 non-AP STAs is considered in this test. Both non-HT (802.11a)
+ * and HE devices are tested. Two TXOPs are simulated in this test:
+ * - In the first TXOP, the AP sends a QoS data frame to each of the three STAs. The Ack in
+ *   response to the initial frame is corrupted, hence the AP terminates the TXOP and tries again
+ *   when a new TXOP is gained. In the new TXOP, the initial frame sent to STA 1 is successfully
+ *   received, while the second frame to STA 2 is corrupted. It is checked that the AP performs
+ *   PIFS recovery or invokes backoff depending on the value of the PifsRecovery attribute. All
+ *   QoS data frames transmitted have a length/duration that does not exceed the length/duration
+ *   based RTS/CTS threshold, hence RTS/CTS is never used.
+ * - In the second TXOP, the AP sends a QoS data frame, in case of non-HT devices, or an A-MPDU
+ *   consisting of 2 MPDUs, in case of HE devices, to each of the three STAs. All PSDUs transmitted
+ *   have a length/duration that exceeds the length/duration based RTS/CTS threshold, hence RTS/CTS
+ *   is used to protect every PSDU, unless the SingleRtsPerTxop attribute is set to true, in which
+ *   case only the initial frame in the TXOP is protected by RTS/CTS.
  */
 class WifiTxopTest : public TestCase
 {
   public:
+    /// Parameters for this test
+    struct Params
+    {
+        bool nonHt;        //!< use 802.11a standard if true, 802.11ax standard otherwise
+        bool pifsRecovery; //!< whether PIFS recovery is used after failure of a non-initial frame
+        bool singleRtsPerTxop; //!< whether protection mechanism is used no more than once per TXOP
+        bool lengthBasedRtsCtsThresh; //!< if true, use length based RTS/CTS threshold; if false,
+                                      //!< use TX duration based RTS/CTS threshold
+    };
+
     /**
      * Constructor
-     * \param pifsRecovery whether PIFS recovery is used after failure of a non-initial frame
+     * \param params parameters for the Wi-Fi TXOP test
      */
-    WifiTxopTest(bool pifsRecovery);
-    ~WifiTxopTest() override;
+    WifiTxopTest(const Params& params);
 
     /**
      * Function to trace packets received by the server application
@@ -89,38 +115,63 @@
     {
         Time txStart;          ///< Frame start TX time
         Time txDuration;       ///< Frame TX duration
+        uint32_t size;         ///< PSDU size in bytes
         WifiMacHeader header;  ///< Frame MAC header
         WifiTxVector txVector; ///< TX vector used to transmit the frame
     };
 
-    uint16_t m_nStations;             ///< number of stations
-    NetDeviceContainer m_staDevices;  ///< container for stations' NetDevices
-    NetDeviceContainer m_apDevices;   ///< container for AP's NetDevice
-    std::vector<FrameInfo> m_txPsdus; ///< transmitted PSDUs
-    Time m_txopLimit;                 ///< TXOP limit
-    uint8_t m_aifsn;                  ///< AIFSN for BE
-    uint32_t m_cwMin;                 ///< CWmin for BE
-    uint16_t m_received;              ///< number of packets received by the stations
-    bool m_pifsRecovery;              ///< whether to use PIFS recovery
+    uint16_t m_nStations;                ///< number of stations
+    NetDeviceContainer m_staDevices;     ///< container for stations' NetDevices
+    NetDeviceContainer m_apDevices;      ///< container for AP's NetDevice
+    std::vector<FrameInfo> m_txPsdus;    ///< transmitted PSDUs
+    Time m_apTxopLimit;                  ///< TXOP limit for AP (AC BE)
+    uint8_t m_staAifsn;                  ///< AIFSN for STAs (AC BE)
+    uint32_t m_staCwMin;                 ///< CWmin for STAs (AC BE)
+    uint32_t m_staCwMax;                 ///< CWmax for STAs (AC BE)
+    Time m_staTxopLimit;                 ///< TXOP limit for STAs (AC BE)
+    uint16_t m_received;                 ///< number of packets received by the stations
+    bool m_nonHt;                        ///< whether to use 802.11a or 802.11ax
+    std::size_t m_payloadSizeRtsOn;      ///< size in bytes of packets protected by RTS
+    std::size_t m_payloadSizeRtsOff;     ///< size in bytes of packets not protected by RTS
+    Time m_startTime;                    ///< time when data frame exchanges start
+    WifiMode m_mode;                     ///< wifi mode used to transmit data frames
+    bool m_pifsRecovery;                 ///< whether to use PIFS recovery
+    bool m_singleRtsPerTxop;             ///< whether to use single RTS per TXOP
+    bool m_lengthBasedRtsCtsThresh;      ///< whether to use length based RTS/CTS threshold
+    Ptr<ListErrorModel> m_apErrorModel;  ///< error model to install on the AP
+    Ptr<ListErrorModel> m_staErrorModel; ///< error model to install on a STA
+    bool m_apCorrupted;  ///< whether the frame to be corrupted by the AP has been corrupted
+    bool m_staCorrupted; ///< whether the frame to be corrupted by the STA has been corrupted
 };
 
-WifiTxopTest::WifiTxopTest(bool pifsRecovery)
+WifiTxopTest::WifiTxopTest(const Params& params)
     : TestCase("Check correct operation within TXOPs"),
       m_nStations(3),
-      m_txopLimit(MicroSeconds(4768)),
+      m_apTxopLimit(MicroSeconds(4768)),
+      m_staAifsn(4),
+      m_staCwMin(63),
+      m_staCwMax(511),
+      m_staTxopLimit(MicroSeconds(3232)),
       m_received(0),
-      m_pifsRecovery(pifsRecovery)
-{
-}
-
-WifiTxopTest::~WifiTxopTest()
+      m_nonHt(params.nonHt),
+      m_payloadSizeRtsOn(m_nonHt ? 2000 : 540),
+      m_payloadSizeRtsOff(500),
+      m_startTime(MilliSeconds(m_nonHt ? 410 : 520)),
+      m_mode(m_nonHt ? OfdmPhy::GetOfdmRate12Mbps() : HePhy::GetHeMcs0()),
+      m_pifsRecovery(params.pifsRecovery),
+      m_singleRtsPerTxop(params.singleRtsPerTxop),
+      m_lengthBasedRtsCtsThresh(params.lengthBasedRtsCtsThresh),
+      m_apErrorModel(CreateObject<ListErrorModel>()),
+      m_staErrorModel(CreateObject<ListErrorModel>()),
+      m_apCorrupted(false),
+      m_staCorrupted(false)
 {
 }
 
 void
 WifiTxopTest::L7Receive(std::string context, Ptr<const Packet> p, const Address& addr)
 {
-    if (p->GetSize() >= 500)
+    if (p->GetSize() >= m_payloadSizeRtsOff)
     {
         m_received++;
     }
@@ -132,23 +183,56 @@
                        WifiTxVector txVector,
                        double txPowerW)
 {
+    bool corrupted{false};
+
+    // The AP does not correctly receive the Ack sent in response to the QoS
+    // data frame sent to the first station
+    if (const auto& hdr = psduMap.begin()->second->GetHeader(0);
+        hdr.IsAck() && !m_apCorrupted && !m_txPsdus.empty() &&
+        m_txPsdus.back().header.IsQosData() &&
+        m_txPsdus.back().header.GetAddr1() == m_staDevices.Get(0)->GetAddress())
+    {
+        corrupted = m_apCorrupted = true;
+        m_apErrorModel->SetList({psduMap.begin()->second->GetPacket()->GetUid()});
+    }
+
+    // The second station does not correctly receive the first QoS data frame sent by the AP
+    if (const auto& hdr = psduMap.begin()->second->GetHeader(0);
+        !m_txPsdus.empty() && hdr.IsQosData() &&
+        hdr.GetAddr1() == m_staDevices.Get(1)->GetAddress())
+    {
+        if (!m_staCorrupted)
+        {
+            corrupted = m_staCorrupted = true;
+        }
+        if (corrupted)
+        {
+            m_staErrorModel->SetList({psduMap.begin()->second->GetPacket()->GetUid()});
+        }
+        else
+        {
+            m_staErrorModel->SetList({});
+        }
+    }
+
     // Log all transmitted frames that are not beacon frames and have been transmitted
-    // after 400ms (so as to skip association requests/responses)
-    if (!psduMap.begin()->second->GetHeader(0).IsBeacon() && Simulator::Now() > MilliSeconds(400))
+    // after the start time (so as to skip association requests/responses)
+    if (!psduMap.begin()->second->GetHeader(0).IsBeacon() && Simulator::Now() >= m_startTime)
     {
         m_txPsdus.push_back({Simulator::Now(),
                              WifiPhy::CalculateTxDuration(psduMap, txVector, WIFI_PHY_BAND_5GHZ),
+                             psduMap[SU_STA_ID]->GetSize(),
                              psduMap[SU_STA_ID]->GetHeader(0),
                              txVector});
     }
 
     // Print all the transmitted frames if the test is executed through test-runner
-    std::cout << Simulator::Now() << " " << psduMap.begin()->second->GetHeader(0).GetTypeString()
-              << " seq " << psduMap.begin()->second->GetHeader(0).GetSequenceNumber() << " to "
-              << psduMap.begin()->second->GetAddr1() << " TX duration "
-              << WifiPhy::CalculateTxDuration(psduMap, txVector, WIFI_PHY_BAND_5GHZ)
-              << " duration/ID " << psduMap.begin()->second->GetHeader(0).GetDuration()
-              << std::endl;
+    NS_LOG_INFO(psduMap.begin()->second->GetHeader(0).GetTypeString()
+                << " seq " << psduMap.begin()->second->GetHeader(0).GetSequenceNumber() << " to "
+                << psduMap.begin()->second->GetAddr1() << " TX duration "
+                << WifiPhy::CalculateTxDuration(psduMap, txVector, WIFI_PHY_BAND_5GHZ)
+                << " duration/ID " << psduMap.begin()->second->GetHeader(0).GetDuration()
+                << (corrupted ? " CORRUPTED" : "") << std::endl);
 }
 
 void
@@ -164,24 +248,37 @@
     NodeContainer wifiStaNodes;
     wifiStaNodes.Create(m_nStations);
 
-    Ptr<SingleModelSpectrumChannel> spectrumChannel = CreateObject<SingleModelSpectrumChannel>();
-    Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel>();
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto lossModel = CreateObject<FriisPropagationLossModel>();
     spectrumChannel->AddPropagationLossModel(lossModel);
-    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
-        CreateObject<ConstantSpeedPropagationDelayModel>();
+    auto delayModel = CreateObject<ConstantSpeedPropagationDelayModel>();
     spectrumChannel->SetPropagationDelayModel(delayModel);
 
     SpectrumWifiPhyHelper phy;
     phy.SetChannel(spectrumChannel);
+    // use default 20 MHz channel in 5 GHz band
+    phy.Set("ChannelSettings", StringValue("{0, 20, BAND_5GHZ, 0}"));
 
     Config::SetDefault("ns3::QosFrameExchangeManager::PifsRecovery", BooleanValue(m_pifsRecovery));
-    Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold", UintegerValue(1900));
+    Config::SetDefault("ns3::WifiDefaultProtectionManager::SingleRtsPerTxop",
+                       BooleanValue(m_singleRtsPerTxop));
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold",
+                           UintegerValue(m_payloadSizeRtsOn * (m_nonHt ? 1 : 2)));
+    }
+    else
+    {
+        Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsTxDurationThresh",
+                           TimeValue(Seconds(m_payloadSizeRtsOn * (m_nonHt ? 1 : 2) * 8.0 /
+                                             m_mode.GetDataRate(20))));
+    }
 
     WifiHelper wifi;
-    wifi.SetStandard(WIFI_STANDARD_80211a);
+    wifi.SetStandard(m_nonHt ? WIFI_STANDARD_80211a : WIFI_STANDARD_80211ax);
     wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
                                  "DataMode",
-                                 StringValue("OfdmRate12Mbps"),
+                                 WifiModeValue(m_mode),
                                  "ControlMode",
                                  StringValue("OfdmRate6Mbps"));
 
@@ -194,15 +291,27 @@
 
     m_staDevices = wifi.Install(phy, mac, wifiStaNodes);
 
-    mac.SetType("ns3::ApWifiMac",
-                "QosSupported",
-                BooleanValue(true),
-                "Ssid",
-                SsidValue(Ssid("wifi-txop-ssid")),
-                "BeaconInterval",
-                TimeValue(MicroSeconds(102400)),
-                "EnableBeaconJitter",
-                BooleanValue(false));
+    mac.SetType(
+        "ns3::ApWifiMac",
+        "QosSupported",
+        BooleanValue(true),
+        "Ssid",
+        SsidValue(Ssid("wifi-txop-ssid")),
+        "BeaconInterval",
+        TimeValue(MicroSeconds(102400)),
+        "EnableBeaconJitter",
+        BooleanValue(false),
+        "AifsnsForSta",
+        StringValue(std::string("BE ") + std::to_string(m_staAifsn)),
+        "CwMinsForSta",
+        ApWifiMac::UintAccessParamsMapValue(
+            ApWifiMac::UintAccessParamsMap{{AC_BE, std::vector<uint64_t>{m_staCwMin}}}),
+        "CwMaxsForSta",
+        StringValue(std::string("BE ") + std::to_string(m_staCwMax)),
+        "TxopLimitsForSta",
+        StringValue(std::string("BE ") + std::to_string(m_staTxopLimit.GetMicroSeconds()) + "us"));
+
+    mac.SetEdca(AC_BE, "TxopLimits", AttributeContainerValue<TimeValue>(std::list{m_apTxopLimit}));
 
     m_apDevices = wifi.Install(phy, mac, wifiApNode);
 
@@ -237,14 +346,6 @@
     mobility.Install(wifiApNode);
     mobility.Install(wifiStaNodes);
 
-    // set the TXOP limit on BE AC
-    dev = DynamicCast<WifiNetDevice>(m_apDevices.Get(0));
-    PointerValue ptr;
-    dev->GetMac()->GetAttribute("BE_Txop", ptr);
-    ptr.Get<QosTxop>()->SetTxopLimit(m_txopLimit);
-    m_aifsn = ptr.Get<QosTxop>()->Txop::GetAifsn();
-    m_cwMin = ptr.Get<QosTxop>()->Txop::GetMinCw();
-
     PacketSocketHelper packetSocket;
     packetSocket.Install(wifiApNode);
     packetSocket.Install(wifiStaNodes);
@@ -257,46 +358,54 @@
         socket.SetPhysicalAddress(m_staDevices.Get(i)->GetAddress());
         socket.SetProtocol(1);
 
+        if (!m_nonHt)
+        {
+            // Send one QoS data frame to establish Block Ack agreement (packet size is such that
+            // this packet is not counted as a received packet)
+            auto client = CreateObject<PacketSocketClient>();
+            client->SetAttribute("PacketSize", UintegerValue(m_payloadSizeRtsOff - 1));
+            client->SetAttribute("MaxPackets", UintegerValue(1));
+            client->SetAttribute("Interval", TimeValue(MicroSeconds(1)));
+            client->SetRemote(socket);
+            wifiApNode.Get(0)->AddApplication(client);
+            client->SetStartTime(m_startTime - MilliSeconds(110 - i * 25));
+            client->SetStopTime(Seconds(1.0));
+        }
+
         // Send one QoS data frame (not protected by RTS/CTS) to each station
-        Ptr<PacketSocketClient> client1 = CreateObject<PacketSocketClient>();
-        client1->SetAttribute("PacketSize", UintegerValue(500));
+        auto client1 = CreateObject<PacketSocketClient>();
+        client1->SetAttribute("PacketSize", UintegerValue(m_payloadSizeRtsOff));
         client1->SetAttribute("MaxPackets", UintegerValue(1));
         client1->SetAttribute("Interval", TimeValue(MicroSeconds(1)));
         client1->SetRemote(socket);
         wifiApNode.Get(0)->AddApplication(client1);
-        client1->SetStartTime(MilliSeconds(410));
+        client1->SetStartTime(m_startTime);
         client1->SetStopTime(Seconds(1.0));
 
         // Send one QoS data frame (protected by RTS/CTS) to each station
-        Ptr<PacketSocketClient> client2 = CreateObject<PacketSocketClient>();
-        client2->SetAttribute("PacketSize", UintegerValue(2000));
-        client2->SetAttribute("MaxPackets", UintegerValue(1));
-        client2->SetAttribute("Interval", TimeValue(MicroSeconds(1)));
+        auto client2 = CreateObject<PacketSocketClient>();
+        client2->SetAttribute("PacketSize", UintegerValue(m_payloadSizeRtsOn));
+        client2->SetAttribute("MaxPackets", UintegerValue(m_nonHt ? 1 : 2));
+        client2->SetAttribute("Interval", TimeValue(Time{0}));
         client2->SetRemote(socket);
         wifiApNode.Get(0)->AddApplication(client2);
-        client2->SetStartTime(MilliSeconds(520));
+        client2->SetStartTime(m_startTime + MilliSeconds(110));
         client2->SetStopTime(Seconds(1.0));
 
-        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
+        auto server = CreateObject<PacketSocketServer>();
         server->SetLocal(socket);
         wifiStaNodes.Get(i)->AddApplication(server);
         server->SetStartTime(Seconds(0.0));
         server->SetStopTime(Seconds(1.0));
     }
 
-    // The AP does not correctly receive the Ack sent in response to the QoS
-    // data frame sent to the first station
-    Ptr<ReceiveListErrorModel> apPem = CreateObject<ReceiveListErrorModel>();
-    apPem->SetList({9});
+    // install the error model on the AP
     dev = DynamicCast<WifiNetDevice>(m_apDevices.Get(0));
-    dev->GetMac()->GetWifiPhy()->SetPostReceptionErrorModel(apPem);
+    dev->GetMac()->GetWifiPhy()->SetPostReceptionErrorModel(m_apErrorModel);
 
-    // The second station does not correctly receive the first QoS
-    // data frame sent by the AP
-    Ptr<ReceiveListErrorModel> sta2Pem = CreateObject<ReceiveListErrorModel>();
-    sta2Pem->SetList({24});
+    // install the error model on the second station
     dev = DynamicCast<WifiNetDevice>(m_staDevices.Get(1));
-    dev->GetMac()->GetWifiPhy()->SetPostReceptionErrorModel(sta2Pem);
+    dev->GetMac()->GetWifiPhy()->SetPostReceptionErrorModel(m_staErrorModel);
 
     // UL Traffic (the first station sends one frame to the AP)
     {
@@ -305,16 +414,30 @@
         socket.SetPhysicalAddress(m_apDevices.Get(0)->GetAddress());
         socket.SetProtocol(1);
 
-        Ptr<PacketSocketClient> client = CreateObject<PacketSocketClient>();
-        client->SetAttribute("PacketSize", UintegerValue(1500));
+        if (!m_nonHt)
+        {
+            // Send one QoS data frame to establish Block Ack agreement (packet size is such that
+            // this packet is not counted as a received packet)
+            auto client = CreateObject<PacketSocketClient>();
+            client->SetAttribute("PacketSize", UintegerValue(m_payloadSizeRtsOff - 1));
+            client->SetAttribute("MaxPackets", UintegerValue(1));
+            client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
+            client->SetRemote(socket);
+            wifiStaNodes.Get(0)->AddApplication(client);
+            client->SetStartTime(m_startTime - MilliSeconds(35));
+            client->SetStopTime(Seconds(1.0));
+        }
+
+        auto client = CreateObject<PacketSocketClient>();
+        client->SetAttribute("PacketSize", UintegerValue(m_payloadSizeRtsOff));
         client->SetAttribute("MaxPackets", UintegerValue(1));
         client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
         client->SetRemote(socket);
         wifiStaNodes.Get(0)->AddApplication(client);
-        client->SetStartTime(MilliSeconds(412));
+        client->SetStartTime(m_startTime + MilliSeconds(2));
         client->SetStopTime(Seconds(1.0));
 
-        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
+        auto server = CreateObject<PacketSocketServer>();
         server->SetLocal(socket);
         wifiApNode.Get(0)->AddApplication(server);
         server->SetStartTime(Seconds(0.0));
@@ -338,13 +461,44 @@
 void
 WifiTxopTest::CheckResults()
 {
+    // check that STAs used the access parameters advertised by the AP
+    for (uint32_t i = 0; i < m_staDevices.GetN(); ++i)
+    {
+        auto staEdca = DynamicCast<WifiNetDevice>(m_staDevices.Get(i))->GetMac()->GetQosTxop(AC_BE);
+        NS_TEST_EXPECT_MSG_EQ(staEdca->GetAifsn(SINGLE_LINK_OP_ID),
+                              m_staAifsn,
+                              "Unexpected AIFSN for STA " << i);
+        NS_TEST_EXPECT_MSG_EQ(staEdca->GetMinCw(SINGLE_LINK_OP_ID),
+                              m_staCwMin,
+                              "Unexpected CWmin for STA " << i);
+        NS_TEST_EXPECT_MSG_EQ(staEdca->GetMaxCw(SINGLE_LINK_OP_ID),
+                              m_staCwMax,
+                              "Unexpected CWmax for STA " << i);
+        NS_TEST_EXPECT_MSG_EQ(staEdca->GetTxopLimit(SINGLE_LINK_OP_ID),
+                              m_staTxopLimit,
+                              "Unexpected TXOP limit for STA " << i);
+    }
+
+    const auto apDev = DynamicCast<WifiNetDevice>(m_apDevices.Get(0));
+
+    NS_TEST_EXPECT_MSG_EQ(apDev->GetMac()->GetQosTxop(AC_BE)->GetTxopLimit(SINGLE_LINK_OP_ID),
+                          m_apTxopLimit,
+                          "Unexpected TXOP limit for AP");
+
+    const auto aifsn = apDev->GetMac()->GetQosTxop(AC_BE)->GetAifsn(SINGLE_LINK_OP_ID);
+    const auto cwMin = apDev->GetMac()->GetQosTxop(AC_BE)->GetMinCw(SINGLE_LINK_OP_ID);
     Time tEnd;                        // TX end for a frame
     Time tStart;                      // TX start for the next frame
     Time txopStart;                   // TXOP start time
     Time tolerance = NanoSeconds(50); // due to propagation delay
-    Time sifs = DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetPhy()->GetSifs();
-    Time slot = DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetPhy()->GetSlot();
+    Time sifs = apDev->GetPhy()->GetSifs();
+    Time slot = apDev->GetPhy()->GetSlot();
     Time navEnd;
+    TypeId::AttributeInformation info;
+    WifiRemoteStationManager::GetTypeId().LookupAttributeByName("RtsCtsThreshold", &info);
+    const uint32_t rtsCtsThreshold = DynamicCast<const UintegerValue>(info.initialValue)->Get();
+    WifiRemoteStationManager::GetTypeId().LookupAttributeByName("RtsCtsTxDurationThresh", &info);
+    const Time rtsCtsTxDurationThresh = DynamicCast<const TimeValue>(info.initialValue)->Get();
 
     // lambda to round Duration/ID (in microseconds) up to the next higher integer
     auto RoundDurationId = [](Time t) {
